"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.declarations = void 0;
const typedoc_1 = require("typedoc");
const model_1 = require("../model");
/**
 * List of options for the plugin
 * @internal
 */
exports.declarations = {
    commandsDir: {
        defaultValue: 'commands',
        help: `(${model_1.NS}) Name of "commands" directory under the TypeDoc output directory. Not a full path`,
        name: 'commandsDir',
        type: typedoc_1.ParameterType.String,
    },
    forceBreadcrumbs: {
        defaultValue: false,
        help: `(${model_1.NS}) Force breadcrumbs to be shown; overrides "hideBreadcrumbs"`,
        name: 'forceBreadcrumbs',
        type: typedoc_1.ParameterType.Boolean,
    },
    outputBuiltinCommands: {
        defaultValue: false,
        help: `(${model_1.NS}) Output builtin commands`,
        name: 'outputBuiltinCommands',
        type: typedoc_1.ParameterType.Boolean,
    },
    outputModules: {
        defaultValue: true,
        help: `(${model_1.NS}) Output modules APIs in addition to commands. This is needed for complete typing information`,
        name: 'outputModules',
        type: typedoc_1.ParameterType.Boolean,
    },
};
// these are extra type checks to ensure these are the correct type.
exports.declarations.outputModules;
exports.declarations.forceBreadcrumbs;
exports.declarations.outputBuiltinCommands;
exports.declarations.commandsDir;
//# sourceMappingURL=declarations.js.map